/* ==========================================================================
**
**                         StringList.h
** 1991 WILLISoft
**
** ==========================================================================
*/

#ifndef STRINGLIST_H
#define STRINGLIST_H

#include <exec/types.h>

typedef struct StringList
{
   char   **Entries;     /* Pointer to an array of strings. */
   UBYTE   *Qualifiers;  /* An array of byte flags */
   USHORT   nEntries;    /* # of entries. */
} StringList;


void StringList_Init( 
   #ifdef ANSI_HEADERS
                           StringList *slist, BOOL Qualify 
   #endif
                    );
   /*
   ** If 'Qualify == TRUE', then the Qualifier array is used,
   ** otherwise it is not.
   */

void StringList_CleanUp( 
   #ifdef ANSI_HEADERS
                           StringList *slist 
   #endif
                       );

BOOL StringList_AddString( 
   #ifdef ANSI_HEADERS
                           StringList *slist,
                           char       *string,
                           BYTE        qualifier 
   #endif
                         );
   /*
   ** Returns false if couldn't allocate memory.
   */

BOOL StringList_AddStrings( 
   #ifdef ANSI_HEADERS
                            StringList  *slist,
                            char       **strings,
                            BYTE        *qualifiers 
   #endif
                          );
   /*
   ** This is an easy way of adding a set of strings to a list.
   ** 'strings' is a NULL terminated list of strings that you
   ** added (e.g. {"This", "That", "The other", NULL}; )
   ** 'qualifiers', if not NULL, is an array of BYTE values
   ** to use as the qualifiers.  (These do NOT need to be NULL
   ** terminated).
   */


BOOL StringList_DeleteString( 
   #ifdef ANSI_HEADERS
                              StringList *slist, USHORT n 
   #endif
                            );
   /*
   ** 'n' is the ordinal number of the string from the
   ** beginning of the list.
   */

BOOL StringList_DeleteAllStrings( 
   #ifdef ANSI_HEADERS
                                    StringList *slist 
   #endif
                                );


void StringList_Sort( 
   #ifdef ANSI_HEADERS
                        StringList *slist 
   #endif
                    );

BOOL StringList_Dup( 
   #ifdef ANSI_HEADERS
                     StringList *source, StringList *target 
   #endif
                   );

#endif
