/* ==========================================================================
**
**                         StringLister.h
**
** PObject<GraphicObject<Interactor<StringLister
**
** A StringLister is an object whose primary purpose in life is to
** manage a list of strings.  (ScrollingLists, ListEditors)
**
** 1991, 1992 WILLISoft
**
** ==========================================================================
*/

#ifndef STRINGLISTER_H
#define STRINGLISTER_H

#include "Interactor.h"
#include "StringList.h"


typedef Interactor StringLister;


BOOL AddString( 
   #ifdef ANSI_HEADERS
                  StringLister *self, char *string, UBYTE qualifier 
   #endif
              );

BOOL DeleteString( 
   #ifdef ANSI_HEADERS
                   StringLister *self, USHORT i 
   #endif
                 );


BOOL DeleteAllStrings( 
   #ifdef ANSI_HEADERS
                        StringLister *self 
   #endif
                     );

const StringList *StringList_of( 
   #ifdef ANSI_HEADERS
                                 StringLister *self 
   #endif
                               );
   /*
   ** IMPORTANT: Treat the returned list as *READ ONLY*
   */

void SelectString( 
   #ifdef ANSI_HEADERS
                     StringLister *self, 
                     USHORT i,  
                     BOOL select 
   #endif
                 );

#endif
