/* ==========================================================================
**
**                               pcgWindow.h
**
** PObject<GraphicObject<Interactor<pcgWindow
**
** 1991 WILLISoft
**
** ==========================================================================
*/

#ifndef PCGWINDOW_H
#define PCGWINDOW_H


#include <intuition/intuition.h>
#include "PObject.h"
#include "Interactor.h"

typedef struct pcgWindow
   {
      Class                 *isa;
      char                  *PObjectName;
      void                  *Next;      /* Not used. */
      struct pcgWindow      *IaWindow;  /* not used. */
      Point                  Location;
      Point                  Size;
      struct NewWindow       NewWindow;
      struct Window         *Window;
      ULONG                  IDCMPFlags;
      struct Interactor     *FirstInteractor;
      struct GraphicObject  *FirstGraphic;
      struct MsgPort        *SharedUserPort;
      Menu                  *MenuStrip;
   } pcgWindow;

/*
   The field 'IDCMPFlags' maintains the current IDCMP values.  The field
   NewWindow.IDCMPFlags contains the bare minimum IDCMP values that the
   window must have.  (Other IDCMP flags are set automagically by adding
   Interactors to the window.

   NOTE: If SharedUserPort is not NULL, it is assumed to be a pointer to
   a valid MessagePort structure, and that the window is to use this
   MessagePort as its UserPort instead of creating its own.

   This is useful for having multiple windows sharing one MessagePort.
   (See the Amiga 1.3 RKMs:  Libraries and Devices, Chapter 7, page 171
   for more details on sharing UserPorts.
 */




void pcgWindow_Init( 
   #ifdef ANSI_HEADERS
                     pcgWindow     *self,
                     UWORD          leftedge,
                     UWORD          topedge,
                     UWORD          width,
                     UWORD          height,
                     UWORD          minwidth,
                     UWORD          minheight,
                     UWORD          maxwidth,
                     UWORD          maxheight,
                     char          *title,
                     ULONG          IDCMPFlags,
                     ULONG          flags,
                     struct Screen *screen 
   #endif
                   );



struct Window *pcgOpenWindow( 
   #ifdef ANSI_HEADERS
                  pcgWindow *self 
   #endif
                  );

void pcgCloseWindow( 
   #ifdef ANSI_HEADERS
                        pcgWindow  *self 
   #endif
                     );

struct Window *iWindow( pcgWindow *self );
   /* returns a pointer to the Intuition window. */

RastPort *RPort( pcgWindow *self );

ULONG SetIDCMPFlags( 
   #ifdef ANSI_HEADERS
                        pcgWindow *self, 
                        ULONG newflags 
   #endif
                   );


void AddWindowPObject ( 
   #ifdef ANSI_HEADERS
                         pcgWindow       *window,
                         GraphicObject   *graphic 
   #endif
                      );


void RemoveWindowPObject( 
   #ifdef ANSI_HEADERS
                           pcgWindow      *window,
                           GraphicObject  *graphic 
   #endif
                        );


void AddMenuStrip( 
   #ifdef ANSI_HEADERS
                     pcgWindow *window, Menu *menustrip 
   #endif
                 );


void RemoveMenuStrip( 
   #ifdef ANSI_HEADERS
                        pcgWindow *window 
   #endif
                    );

#endif
