#ifndef AMIGAMEM_H
#define AMIGAMEM_H

/*
   These are versions of the standard C memory utilities, except these 
   use AllocMem rather than the process' heap.

   (If you want to make a shared library, or even a .lib file that
   others (non SAS users) can link to, stay away from the heap
   memory routines.)

   *DO NOT* mix memory allocated off the heap with memory allocated
   with these routines!!!

   Lee Willis, Oct 1992
*/

#include <exec/types.h>

void* Amalloc( ULONG );

void* Acalloc( ULONG, ULONG );

char* Astrdup( const char* );

void Afree( void* );


void *Arealloc( void *, ULONG );

#endif 