/* ==========================================================================
**
**                   EmbossedGadgetClass.h
**
** 1991 WILLISoft
**
** ==========================================================================
*/

#ifndef EMBOSSEDGADGETCLASS_H
#define EMBOSSEDGADGETCLASS_H


#include "EmbossedGadget.h"
#include "InteractorClass.h"

void EmbossedGadget_Init( EmbossedGadget *gadget,
                          PIXELS          LeftEdge,
                          PIXELS          TopEdge,
                          PIXELS          Width,
                          PIXELS          Height,
                          USHORT          Flags,
                          USHORT          Activation,
                          USHORT          GadgetType,
                          pcg_3DPens      Pens,
                          char           *Label );


struct InteractorClass *EmbossedGadgetClass( void );

void EmbossedGadgetClass_Init( struct InteractorClass *class );

EmbossedGadget *EmbossedGadget_New( EmbossedGadget *self );

void EmbossedGadget_CleanUp( EmbossedGadget *self );

tPoint EmbossedGadget_SetLocation(  EmbossedGadget *self,
                                    PIXELS          LeftEdge,
                                    PIXELS          TopEdge );

tPoint EmbossedGadget_AskSize( EmbossedGadget *self,
                               PIXELS          Width,
                               PIXELS          Height );

tPoint EmbossedGadget_SetSize( EmbossedGadget *self,
                               PIXELS          Width,
                               PIXELS          Height );

Gadget *EmbossedGadget_FirstGadget( EmbossedGadget *self );


USHORT EmbossedGadget_nGadgets( EmbossedGadget *self );


ULONG EmbossedGadget_IDCMPFlags( EmbossedGadget *self );


USHORT EmbossedGadget_ClaimEvent( EmbossedGadget *self,
                                  IntuiMessage   *event );


USHORT EmbossedGadget_Respond( EmbossedGadget   *self,
                               IntuiMessage     *Event );


void EmbossedGadget_Refresh( EmbossedGadget *self );
/* Performs a 'RefreshGList()' on the gadget(s) of self. */


void EmbossedGadget_Render( EmbossedGadget *self,
                            RastPort       *RPort );
/* Attempts to draw the Gadget Border/Image, and GadgetText to RPort. */


BOOL EmbossedGadget_EnableIactor( EmbossedGadget *self,
                            BOOL            enable );


BOOL EmbossedGadget_isEnabled( Interactor *self,
                               BOOL       enable );

char *EmbossedGadget_Title( EmbossedGadget *self );

BOOL EmbossedGadget_SetTitle( EmbossedGadget *self,
                              char           *title );

#endif
