/* ==========================================================================
**
**                   GraphicObjectClass.h
**
** 1991 WILLISoft
**
** ==========================================================================
*/

#ifndef GRAPHICOBJECTCLASS_H
#define GRAPHICOBJECTCLASS_H

#include "PObjectClass.h"
#include "GraphicObject.h"


struct GraphicObjectClass
{
	OBJECTMETHODS

   Point (*Location)( GraphicObject *self );

   Point (*SetLocation)
            ( GraphicObject *self,
              PIXELS       LeftEdge,
              PIXELS       TopEdge );
   Point (*Size)( GraphicObject *self );

   Point (*AskSize)
            ( GraphicObject *self,
              PIXELS       Width,
              PIXELS       Height );

   Point (*SetSize)
            ( GraphicObject *self,
              PIXELS       Width,
              PIXELS       Height );

   UWORD  (*SizeFlags)
            ( GraphicObject *self );

   void (*Render)
            ( GraphicObject *self,
              RastPort     *RPort );

   BOOL (*SetTitle)
            ( GraphicObject *self,
              char          *title );

   char *(*Title)( GraphicObject *self );

   AlignInfo (*TextAlignment)
            ( GraphicObject *self );

   AlignInfo (*SetTextAlignment)
            ( GraphicObject *self,
              UBYTE        Flags,
              BYTE          Xpad,
              BYTE          Ypad );

   struct BuilderMethods *BuilderMethods;

};


struct GraphicObjectClass *GraphicObjectClass( void );

void GraphicObjectClass_Init( struct GraphicObjectClass *class );

UWORD GraphicObject_SizeFlagsNone( GraphicObject *self );
UWORD GraphicObject_SizeFlagsX( GraphicObject *self );
UWORD GraphicObject_SizeFlagsY( GraphicObject *self );
UWORD GraphicObject_SizeFlagsAll( GraphicObject *self );




AlignInfo TextAlignment( GraphicObject *self );

AlignInfo SetTextAlignment( GraphicObject *self,
									 UBYTE			 Flags,
									 BYTE			  Xpad,
									 BYTE			  Ypad );


#endif
