/* ==========================================================================
**
**                   InteractorClass.h
**
** 1991 WILLISoft
**
** ==========================================================================
*/

#ifndef INTERACTORCLASS_H
#define INTERACTORCLASS_H

#include <exec/types.h>
#include "Interactor.h"
#include "GraphicObjectClass.h"


struct InteractorClass
{
   Class *isa;
   char  *ClassName;

   void   (*CleanUp)
            ( Interactor *self );
   tPoint (*Location)
            ( const Interactor *self );
   tPoint (*SetLocation)
            ( Interactor *self,
              PIXELS      LeftEdge,
              PIXELS      TopEdge );
   tPoint (*Size)
            ( const Interactor *self );
   tPoint (*AskSize)
            ( const Interactor *self,
              PIXELS            Width,
              PIXELS            Height );
   tPoint (*SetSize)
            ( Interactor *self,
              PIXELS      Width,
              PIXELS      Height );
   UWORD  (*SizeFlags)
            ( const Interactor *self );

   void (*Render)
            ( Interactor *self,
              RastPort  *RPort );

   BOOL (*SetTitle)
            ( Interactor *self,
              char      *title );

   char *(*Title)
            ( Interactor *self );

   AlignInfo (*TextAlignment)( GraphicObject *self );

   AlignInfo (*SetTextAlignment)
            ( GraphicObject *self,
              UBYTE         Flags,
              BYTE          Xpad,
              BYTE          Ypad );    Class *BuilderMethods;

/*--- New Methods ----------------------------*/

   struct pcgWindow *(*InteractorWindow)
            ( Interactor *self );

   void (*SetInteractorWindow)
            ( Interactor         *self,
              struct pcgWindow *window );

   Gadget *(*FirstGadget)
            ( Interactor *self );

   USHORT (*nGadgets)
            ( Interactor *self );

   ULONG (*IDCMPFlags)
            ( Interactor *self );

   USHORT (*ClaimEvent)
            ( Interactor    *self,
              IntuiMessage *event );

   USHORT (*Respond)
            ( Interactor    *self,
              IntuiMessage *event );

   void (*Refresh)
            ( Interactor    *self );

   BOOL (*EnableIactor)
            ( Interactor *self,
              BOOL       enable );

   BOOL (*isEnabled)
            ( Interactor *self  );

   BOOL (*Activate)
            ( Interactor *self,
              BOOL       activate );

   BOOL (*isActive)
            ( Interactor *self );

};

struct InteractorClass *InteractorClass( void );

void InteractorClass_Init( struct InteractorClass *class );

#endif