#ifndef OBJECTCLASS_H
#define OBJECTCLASS_H

/* ==========================================================================
**
**                               PObjectClass.h
**
**   1991 WILLISoft
**
** ==========================================================================
*/

#include "PObject.h"

/* PObjectClass contains pointers to the methods (functions)
** applicable to type PObject.
**
** CONVENTIONS:
**
**    The structure which describes the class 'Abc' is
**    always named 'struct AbcClass'.
**
**    The function that returns a pointer to the class structure is
**    'struct AbcClass *AbcClass();'.
*/

#define OBJECTMETHODS \
   Class *isa;        \
   char  *ClassName;  \
   void  (*CleanUp)( PObject *self );

struct PObjectClass
{
   OBJECTMETHODS
};

void PObjectClass_Init( struct PObjectClass *class );

const struct PObjectClass *PObjectClass( void );

BOOL isa( const PObject *self,
          const Class  *class );

/* Returns TRUE of 'self' is one of 'class', or its descendents. */

char *PObjectName( PObject *self );

void SetPObjectName( PObject *self, char *name );

#endif