

#include "Positioner.h"
#include "PositionerClass.h"
#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/graphics.h>
#include "amigamem.h"


USHORT KnobSize( Positioner *self )
{
   struct PositionerClass *class;


   if (class = (struct PositionerClass *) self->isa)
   {
      if (class->KnobSize)
         return (*class->KnobSize)( self );
   }
   else
      return 0;
}


USHORT SetKnobSize( Positioner *self, USHORT knobsize )
{
   struct PositionerClass *class;


   if (class = (struct PositionerClass *) self->isa)
   {
      if (class->SetKnobSize)
         return (*class->SetKnobSize)( self, knobsize );
   }
   else
      return 0;
}

BOOL Positioner_elaborated = FALSE;

struct PositionerClass Positioner_Class;

void PositionerClass_Init( struct PositionerClass *class )
{
   ValuatorClass_Init( (struct ValuatorClass *) class );
   class->isa           = ValuatorClass();
   class->ClassName     = "Positioner";
   class->Value         = NULL;
   class->SetValue      = NULL;
   class->KnobSize      = NULL;
   class->SetKnobSize   = NULL;
}


struct PositionerClass *PositionerClass( void )
{
   if (! Positioner_elaborated)
   {
      PositionerClass_Init( &Positioner_Class );
      Positioner_elaborated = TRUE;
   }

   return &Positioner_Class;
}


void Positioner_Init( Positioner *self )
{
   Valuator_Init(self);
}