/* ==========================================================================
**
**                   PositionerClass.h
**
** 1991 WILLISoft
**
** ==========================================================================
*/

#ifndef POSITIONERCLASS_H
#define POSITIONERCLASS_H

#include "Positioner.h"
#include "ValuatorClass.h"


struct PositionerClass
{
   Class *isa;
   char  *ClassName;

   void   (*CleanUp)
            ( Positioner *self );
   Point (*Location)
            ( const Positioner *self );
   Point (*SetLocation)
            ( Positioner *self,
              PIXELS      LeftEdge,
              PIXELS      TopEdge );
   Point (*Size)
            ( const Positioner *self );
   Point (*AskSize)
            ( const Positioner *self,
              PIXELS            Width,
              PIXELS            Height );
   Point (*SetSize)
            ( Positioner *self,
              PIXELS      Width,
              PIXELS      Height );
   UWORD  (*SizeFlags)
            ( const Positioner *self );

   void (*Render)
            ( Positioner *self,
              RastPort  *RPort );

   BOOL (*SetTitle)
            ( Positioner *self,
              char      *title );

   char *(*Title)
            ( Positioner *self );

   AlignInfo (*TextAlignment)( GraphicObject *self );

   AlignInfo (*SetTextAlignment)
            ( GraphicObject *self,
              UBYTE         Flags,
              BYTE          Xpad,
              BYTE          Ypad );

   Class *BuilderMethods;

   struct pcgWindow *(*InteractorWindow)
            ( Positioner *self );

   void (*SetInteractorWindow)
            ( Positioner       *self,
              struct pcgWindow *window );

   Gadget *(*FirstGadget)
            ( Positioner *self );

   USHORT (*nGadgets)
            ( Positioner *self );

   ULONG (*IDCMPFlags)
            ( Positioner *self );

   USHORT (*ClaimEvent)
            ( Positioner   *self,
              IntuiMessage *event );

   USHORT (*Respond)
            ( Positioner   *self,
              IntuiMessage *event );

   void (*Refresh)
            ( Positioner    *self );

   BOOL (*EnableIactor)
            ( Positioner *self,
              BOOL       enable );

   BOOL (*isEnabled)
            ( Positioner *self  );

   BOOL (*Activate)
            ( Positioner *self,
              BOOL       activate );

   BOOL (*isActive)
            ( Positioner *self );

   LONG (*Value)
            ( Positioner *self );

   LONG (*SetValue)
            ( Positioner *self,
              LONG      selection );

/*--- New Methods ----------------------------*/

   USHORT (*KnobSize)
            ( Positioner *self );

   USHORT (*SetKnobSize)
            ( Positioner *self,
              USHORT      knobsize );

};


struct PositionerClass *PositionerClass( void );

void PositionerClass_Init( struct PositionerClass *class );


#endif
