/* ==========================================================================
**
**                         SliderClass.h
** 1991 WILLISoft
**
** ==========================================================================
*/

#ifndef SLIDERCLASS_H
#define SLIDERCLASS_H

#include "Slider.h"
#include "PositionerClass.h"

struct PositionerClass *SliderClass( void );

void SlideLower( Slider *self );

void SlideHigher( Slider *self );


void Slider_ScrollUp   ( Slider *slider, pcgWindow *window );
void Slider_ScrollDown ( Slider *slider, pcgWindow *window );
void Slider_ScrollLeft ( Slider *slider, pcgWindow *window );
void Slider_ScrollRight( Slider *slider, pcgWindow *window );


void Slider_CleanUp( Slider *self );

void Slider_Render( Slider *self, RastPort *RPort );

Point Slider_SetLocation( Slider *self,
                          PIXELS  LeftEdge,
                          PIXELS  TopEdge );

Point Slider_AskSize( Slider *self,
                      PIXELS  Width,
                      PIXELS  Height );

Point Slider_SetSize( Slider *self,
                      PIXELS  Width,
                      PIXELS  Height );



void Slider_Init( Slider       *self,
                  PIXELS        LeftEdge,
                  PIXELS        TopEdge,
                  PIXELS        Width,
                  PIXELS        Height,
                  pcg_3DPens    Pens );
/* The following function initializes an autoknob
** propgadget.  The gadget is initialized to be full size.
** The relevant fields which are initialized are:
**    Flags        = GADGHCOMP;
**    GadgetType   = PROPGADGET;
**    GadgetRender = &AutoKnob;
**    SelectRender = NULL;
**    SpecialInfo  = &Prop;
**    Prop.Flags   = AUTOKNOB | BORDERLESS;
**
** You have to do everything else.
*/


void SliderClass_Init( struct PositionerClass *class );



/*
** SlideLower() moves the slider knob toward position 0. NOTE that
** 'Lower' is relative to the position range, NOT THE DIRECTION
** IT MOVES ON THE SCREEN.  For a VSlider, position 0 (and therefore
** 'lower') is toward the TOP of the screen.
**
** SlideHigher() moves the slider knob toward position 0xFFFF.
**
** In both cases, the amount of movement is proportional to the
** size of the knob.
*/

#endif