/* ==========================================================================
**
**                         VScrollerClass.h
**
** 1991 WILLISoft
**
** ==========================================================================
*/

#ifndef STRINGLISTERCLASS_H
#define STRINGLISTERCLASS_H

#include "StringLister.h"
#include "InteractorClass.h"


struct StringListerClass
{
   Class *isa;
   char  *ClassName;

   void   (*CleanUp)
            ( Interactor *self );
   Point (*Location)
            ( const Interactor *self );
   Point (*SetLocation)
            ( Interactor *self,
              PIXELS      LeftEdge,
              PIXELS      TopEdge );
   Point (*Size)
            ( const Interactor *self );
   Point (*AskSize)
            ( const Interactor *self,
              PIXELS            Width,
              PIXELS            Height );
   Point (*SetSize)
            ( Interactor *self,
              PIXELS      Width,
              PIXELS      Height );
   UWORD  (*SizeFlags)
            ( const Interactor *self );

   void (*Render)
            ( Interactor *self,
              RastPort  *RPort );

   BOOL (*SetTitle)
            ( Interactor *self,
              char      *title );

   char *(*Title)
            ( Interactor *self );

   AlignInfo (*TextAlignment)( GraphicObject *self );

   AlignInfo (*SetTextAlignment)
            ( GraphicObject *self,
              UBYTE         Flags,
              BYTE          Xpad,
              BYTE          Ypad );

   Class *BuilderMethods;

   struct pcgWindow *(*InteractorWindow)
            ( Interactor *self );

   void (*SetInteractorWindow)
            ( Interactor         *self,
              struct pcgWindow *window );

   Gadget *(*FirstGadget)
            ( Interactor *self );

   USHORT (*nGadgets)
            ( Interactor *self );

   ULONG (*IDCMPFlags)
            ( Interactor *self );

   USHORT (*ClaimEvent)
            ( Interactor    *self,
              IntuiMessage *event );

   USHORT (*Respond)
            ( Interactor    *self,
              IntuiMessage *event );

   void (*Refresh)
            ( Interactor    *self );

   BOOL (*EnableIactor)
            ( Interactor *self,
              BOOL       enable );

   BOOL (*isEnabled)
            ( Interactor *self  );

   BOOL (*Activate)
            ( Interactor *self,
              BOOL       activate );

   BOOL (*isActive)
            ( Interactor *self );

/*----- New methods ---------------*/

   BOOL (*AddString)
            ( StringLister *self, char *string, UBYTE qualifier );

   BOOL (*DeleteString)
            ( StringLister *self, USHORT i );

   BOOL (*DeleteAllStrings)
            ( StringLister *self );

   const StringList *(*StringList_of)
            ( StringLister *self );

   void (*SelectString)
            ( StringLister  *self,
              USHORT         i,
              BOOL           select );
};


void StringLister_Init( StringLister *self );

struct StringListerClass *StringListerClass( void );

void StringListerClass_Init( struct StringListerClass *class );

#endif
