/* ==========================================================================
**
**                   ValuatorClass.h
**
** 1991 WILLISoft
**
** ==========================================================================
*/

#ifndef VALUATORCLASS_H
#define VALUATORCLASS_H

#include "InteractorClass.h"
#include "Valuator.h"


struct ValuatorClass
{
   Class *isa;
   char  *ClassName;

   void   (*CleanUp)
            ( Valuator *self );
   Point (*Location)
            ( Valuator *self );
   Point (*SetLocation)
            ( Valuator *self,
              PIXELS    LeftEdge,
              PIXELS    TopEdge );
   Point (*Size)
            ( Valuator *self );
   Point (*AskSize)
            ( Valuator *self,
              PIXELS    Width,
              PIXELS    Height );
   Point (*SetSize)
            ( Valuator *self,
              PIXELS    Width,
              PIXELS    Height );

   UWORD (*SizeFlags)( Valuator *self );

   void (*Render)
            ( Valuator *self,
              RastPort *RPort );

   BOOL (*SetTitle)
            ( Valuator *self,
              char      *title );

   char *(*Title)
            ( Valuator *self );

   AlignInfo (*TextAlignment)( GraphicObject *self );

   AlignInfo (*SetTextAlignment)
            ( GraphicObject *self,
              UBYTE         Flags,
              BYTE          Xpad,
              BYTE          Ypad );    Class *BuilderMethods;

   struct pcgWindow *(*InteractorWindow)
            ( Valuator *self );

   void (*SetInteractorWindow)
            ( Valuator          *self,
              struct pcg_Window *window );

   Gadget *(*FirstGadget)
            ( Valuator *self );

   USHORT (*nGadgets)
            ( Valuator *self );

   ULONG (*IDCMPFlags)
            ( Valuator *self );

   USHORT (*ClaimEvent)
            ( Valuator     *self,
              IntuiMessage *event );

   USHORT (*Respond)
            ( Valuator     *self,
              IntuiMessage *event );

   void (*Refresh)
            ( Valuator    *self );

   BOOL (*EnableIactor)
            ( Valuator *self,
              BOOL      enable );

   BOOL (*isEnabled)
            ( Valuator *self  );

   BOOL (*Activate)
            ( Valuator *self,
              BOOL      activate );

   BOOL (*isActive)
            ( Valuator *self );


/*--- New Methods ----------------------------*/

   LONG (*Value)
            ( Valuator *self );

   LONG (*SetValue)
            ( Valuator *self,
              LONG      selection );

};


struct ValuatorClass *ValuatorClass( void );

void ValuatorClass_Init( struct ValuatorClass *class );

#endif