#ifndef PCGWINDOWCLASS_H
#define PCGWINDOWCLASS_H

#include "pcgWindow.h"
#include "InteractorClass.h"

struct pcgWindowClass
{
   Class *isa;
   char  *ClassName;

   void   (*CleanUp)
            ( Interactor *self );
   tPoint (*Location)
            ( const Interactor *self );
   tPoint (*SetLocation)
            ( Interactor *self,
              PIXELS      LeftEdge,
              PIXELS      TopEdge );
   tPoint (*Size)
            ( const Interactor *self );
   tPoint (*AskSize)
            ( const Interactor *self,
              PIXELS            Width,
              PIXELS            Height );
   tPoint (*SetSize)
            ( Interactor *self,
              PIXELS      Width,
              PIXELS      Height );
   UWORD  (*SizeFlags)
            ( const Interactor *self );

   void (*Render)
            ( Interactor *self,
              RastPort  *RPort );

   BOOL (*SetTitle)
            ( Interactor *self,
              char       *title );

   char *(*Title)
            ( Interactor *self );

   AlignInfo (*TextAlignment)( GraphicObject *self );

   AlignInfo (*SetTextAlignment)
            ( GraphicObject *self,
              UBYTE         Flags,
              BYTE          Xpad,
              BYTE          Ypad );

   Class *BuilderMethods; /* pointer to more methods only used by the
                          ** interface builder.
                          */

   struct pcgWindow *(*InteractorWindow)
            ( Interactor *self );

   void (*SetInteractorWindow)
            ( Interactor         *self,
              struct pcgWindow *window );

   Gadget *(*FirstGadget)
            ( Interactor *self );

   USHORT (*nGadgets)
            ( Interactor *self );

   ULONG (*IDCMPFlags)
            ( Interactor *self );

   USHORT (*ClaimEvent)
            ( Interactor    *self,
              IntuiMessage *event );

   USHORT (*Respond)
            ( Interactor    *self,
              IntuiMessage *event );

   void (*Refresh)
            ( Interactor    *self );

   BOOL (*EnableIactor)
            ( Interactor *self,
              BOOL       enable );

   BOOL (*isEnabled)
            ( Interactor *self  );

   BOOL (*Activate)
            ( Interactor *self,
              BOOL       activate );

   BOOL (*isActive)
            ( Interactor *self );

/*--- New Methods ----------------------------*/

   struct Window *(*OpenWindow)
            ( pcgWindow *self );

   void (*CloseWindow)
            ( pcgWindow *self );

   struct Window *(*iWindow)
            ( pcgWindow *self );

   RastPort *(*RPort)
            ( pcgWindow *self );

   ULONG (*SetIDCMPFlags)
            ( pcgWindow *self,
              ULONG       newflags );

   void (*AddGraphicObject)
            ( pcgWindow *self, GraphicObject *graphic );

   void (*RemoveGraphicObject)
            ( pcgWindow *self, GraphicObject *graphic );

   void (*AddInteractor)
            ( pcgWindow *self, Interactor *interactor );

   void (*RemoveInteractor)
            ( pcgWindow *self, Interactor *interactor );

   void (*AddMenuStrip)( pcgWindow *window, Menu *menustrip );

   void (*RemoveMenuStrip)( pcgWindow *window );
};

struct pcgWindowClass *pcgWindowClass( void );

void pcgWindowClass_Init( struct pcgWindowClass *class );

#endif